# Présentation

Ceci est le code source du générateur de sites statiques qui créé le [site web d'Antopie](https://antopie.org).

# Utilisation

Placer les pages dans `<site>/md/<page>.md`. Le format est principalement du Markdown Extra mais il est aussi possible de rajouter de l'HTML et du PHP. Elles sont ensuite transformées par `compil.php` en pages HTML statiques, placées dans `<site>/<page>.html`

`compil.php <site> <destination>`

Avec `site` qui est le dossier contenant le site et pour `destination` :
* Pour déployer en DNS en liant vers `page`, utiliser `dns`.
* Pour déployer en Onion en liant vert `page`, utiliser `onion`.
* Pour déployer en DNS en liant vert `page.html`, ignorer ce dernier argument.

Les droits d'écriture sont requis sur `<site>/css` et `temp/` par l'user qui exécute PHP.

`compil.php` va chercher à utiliser [static-compress](https://github.com/neosmart/static-compress) dans `/usr/local/bin/static-compress` pour compresser les fichiers CSS et HTML créés.

```
$ cargo install static-compress
$ sudo mv ~/.cargo/bin/static-compress /usr/local/bin/
```

Exemple de commande pour tester le développement en local après avoir modifié le site : `php compil.php antopie local && python3 -m http.server -b 127.0.0.1 -d antopie`

# Bibliothèques utilisées

Le dossier `bibli` contient les dépendances incluses dans le générateur de sites :

| Nom       | Description                 | Source                                     |
| --------- | --------------------------- | ------------------------------------------ |
| less.php  | Compilateur Less en PHP     | https://github.com/wikimedia/less.php      |
| parsedown | Compilateur Markdown en PHP | https://parsedown.org                      |

Il y a aussi une dépendance spécifique au site d'Antopie :

| Nom       | Description         | Source                                   |
| --------- | ------------------- | ---------------------------------------- |
| fontello  | Pack d'icônes       | http://fontello.com                      |

# Licence

Le générateur de sites web d'Antopie est un logiciel libre ; vous pouvez le diffuser et le modifier suivant les termes de la GNU Affero General Public License telle que publiée par la Free Software Foundation ; soit la version 3 de cette licence, soit (à votre convenance) une version ultérieure.

Le générateur de sites web d'Antopie est diffusé dans l’espoir qu’il sera utile, mais SANS AUCUNE GARANTIE ; sans même une garantie implicite de COMMERCIALISATION ou d’ADÉQUATION À UN USAGE PARTICULIER. Voyez la GNU Affero General Public License pour plus de détails.

Vous devriez avoir reçu une copie de la GNU Affero General Public License avec ce code. Sinon, consultez https://www.gnu.org/licenses/
